Unit IAH4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAH1R_p;

procedure IAH4R(A :Real; B :Real; var C :Array of Real;
                N :Integer; FUNC :Func_F1;
                var CINT :Array of Real; var RF :Array of Real);

implementation

procedure IAH4R(A :Real; B :Real; var C :Array of Real;
                N :Integer; FUNC :Func_F1;
                var CINT :Array of Real; var RF :Array of Real);
var
N1,J :Integer;
CON,SUM,FAC :Real;
label
_10;
begin
IAH1R(A,B,C,N,FUNC,RF);
CON := 0.25*(B-A);
SUM := 0.0;
FAC := 1.0;
N1 := N-1;
for J:=2 to N1 do
 begin
  CINT[J-1] := CON*(C[J-2]-C[J+0])/(J-1);
  SUM := SUM+FAC*CINT[J-1];
  FAC := -FAC;
_10:
 end;
CINT[N-1] := CON*C[N-2]/(N-1);
SUM := SUM+FAC*CINT[N-1];
CINT[0] := 2*SUM;
end;

end.
